Subject: Re: bug#22420: Zsh test failure

From: [email-masked] (Ludovic Courtès)
Date: Sat, 23 Jan 2016 11:51:14 +0100

Leo Famulari <[email-masked]> skribis:

> On Fri, Jan 22, 2016 at 03:38:54PM -0500, Leo Famulari wrote:
>> On Fri, Jan 22, 2016 at 09:34:39PM +0100, Ludovic Courtès wrote:
>> > Leo Famulari <[email-masked]> skribis:
>> > 
>> > > I thought that perhaps it was referring to B02typeset.ztst, but I don't
>> > > think there is anything related in that area of the file:
>> > > 540   (
>> > > 541   setopt glob
>> > > 542   mkdir -p arrayglob
>> > > 543   touch arrayglob/{one,two,three,four,five,six,seven}
>> > > 544   fn() {
>> > > 545     typeset array=(arrayglob/[tf]*)
>> > 
>> > Out of curiosity, what file system is this on?
>> 
>> Both filesystems are btrfs on LVM. The failing system is also using
>> LUKS.

OK.  Btrfs often behaves differently from ext4, exhibiting issues in
various places.

The above test uses uses readdir(2) and friends to test glob patterns,
so this could be an area where Btrfs yields different results.

But anyway, you said /tmp is not on Btrfs.

> Well, actually, that only describes /home, which is perhaps not
> relevant, although I did try and fail to build in a `guix environment
> zsh` "by hand" in /home on the failing machine.
>
> Failing system (separate /tmp):
> /tmp /dev/mapper/bad--vg-tmp on /tmp type ext4 (rw,relatime,stripe=4,data=ordered)
>
> Working system (/tmp on /):
> /dev/mapper/good--vg-root on / type ext4 (rw,relatime,errors=remount-ro,data=ordered)

I’m not sure what could happen here.  Could you try to analyze the test
log and see what exactly is failing?  Once you’ve done that, you could
try to strace the test on both the “good” and the “bad” file system, to
spot the difference.

Alternately, you could leave that for upstream to solve.  ;-)

Thanks,
Ludo’.